if not Recount then return end
local Recount = Recount
local RecountMitigation = LibStub("AceAddon-3.0"):NewAddon("RecountMitigation", "AceEvent-3.0", "AceTimer-3.0")
RecountMitigation.Version = 5.1
local RL = LibStub("AceLocale-3.0"):GetLocale("Recount")
local L = LibStub("AceLocale-3.0"):GetLocale("RecountMitigation")

local mAbsorbs = { -- Ordered by priority
	[116631] = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Colossus") return (v), nil end,
	[77535]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Blood Shield") return (v), true end, --Physical Only (true)
	[65148]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Sacred Shield") return (v), nil end,
	[17]     = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Power Word: Shield") return (v), nil end,
	
}
local mLeft = {}

-- look at combining HTD events as they will be the only ones with times instead of nil. must add check when nessessary below
-- (value, school, type, customDuration)
-- Value = a percentage or amount of damage mitigation
-- School = All, Physical or Magical
-- Type = Percentage or Amount
-- customDuration = duration of spell for HTD
local mBuffAll = {
	[71]     = function() return (0.25), nil end, -- Defensive Stance (Unconfirmed)
	[871]    = function() return (0.40), nil end, -- Shield Wall (Unconfirmed)
	[14771]  = function() return (0.06), nil end, -- Glyph of Inner Sanctum (Unconfirmed)
	[15473]  = function() return (0.15), nil end, -- Shadowform (Unconfirmed)
	[22812]  = function() return (0.20), nil end, -- Barkskin (Unconfirmed)
	[24858]  = function() return (0.15), nil end, -- Moonkin Form (Unconfirmed)
	[30823]  = function() return (0.30), nil end, -- Shamanistic Rage (Unconfirmed)
	[31850]  = function() return (0.20), nil end, -- Ardent Defender
	[33206]  = function() return (0.40), nil end, -- Pain Suppression (Unconfirmed)
	[45182]  = function() return (0.80), nil end, -- Cheating Death (Unconfirmed)
	[48263]  = function() return (0.10), nil end, -- Blood Presence
	[48792]  = function() return (0.50), nil end, -- Icebound Fortitude
	[49222]  = function() return (0.20), nil end, -- Bone Shield (Unconfirmed)
	[54924]  = function() return (0.20), nil end, -- Glyph of Divine Protection (Unconfirmed)
	[55684]  = function() return (0.10), nil end, -- Glyph of Fade (Unconfirmed)
	[63329]  = function() return (0.60), nil end, -- Glyph of Shield Wall (Unconfirmed)
	[65116]  = function() return (0.10), nil end, -- Stoneform
	[65544]  = function() return (0.90), nil end, -- Dispersion (Unconfirmed)
	--[66023]  = function() return (0.45), nil end, -- Icebound Fortitude (Unconfirmed)
	[81164]  = function() return (0.45), nil end, -- Will of the Necropolis (Unconfirmed)
	[105805] = function() return (0.15), nil end, -- Sanctuary (Unconfirmed)
	[110575] = function() return (0.20), nil end, -- Icebound Fortitude - Symbosis (Unconfirmed)
	[113075] = function() return (0.10), nil end, -- Barkskin - Symbosis (Unconfirmed)
}
local mBuffPhysical = {
	[30482]  = function() return (0.06), nil end, -- Molten Armor (Unconfirmed)
	[63269]  = function() return (0.40), nil end, -- Glyph of Cloak of Shadows (Unconfirmed)
	[132403] = function() return (0.30 + (GetMastery()/100)), nil end, -- Shield of the Righteous
}
local mBuffMagical = {
	[498]    = function() return (0.40), nil end, -- Divine Protection
	[31821]  = function() return (0.20), nil end, -- Devotion Aura
	[48707]  = function() return (0.75), nil end, -- Anti-Magic Shell (Unconfirmed)
	[50461]  = function() return (0.75), nil end, -- Anti-Magic Zone (Unconfirmed)
}
local mBuffAllHTD = {
	[86659]  = function() return (0.50), 12 end, -- Guardian of Ancient Kings -- maybe monitor buff instead
}
local mBuffPhysicalHTD = {
}
local mBuffMagicalHTD = {
}
local mBuffRemoveHTD = {}
local mBuffs = {}
for k, v in pairs(mBuffAll) do mBuffs[k] = v end
for k, v in pairs(mBuffPhysical) do mBuffs[k] = v end
for k, v in pairs(mBuffMagical) do mBuffs[k] = v end
local mBuffsHTD = {}
for k, v in pairs(mBuffAllHTD) do mBuffsHTD[k] = v end
for k, v in pairs(mBuffPhysicalHTD) do mBuffsHTD[k] = v end
for k, v in pairs(mBuffMagicalHTD) do mBuffsHTD[k] = v end

local SPELLSCHOOL_PHYSICAL = 1
local SPELLSCHOOL_HOLY = 2
local SPELLSCHOOL_FIRE = 4
local SPELLSCHOOL_NATURE = 8
local SPELLSCHOOL_NATUREFIRE = SPELLSCHOOL_FIRE + SPELLSCHOOL_NATURE
local SPELLSCHOOL_FROST = 16
local SPELLSCHOOL_FROSTFIRE = SPELLSCHOOL_FIRE + SPELLSCHOOL_FROST
local SPELLSCHOOL_SHADOW = 32
local SPELLSCHOOL_ARCANE = 64

local DetailTitles={}
DetailTitles.DamageMitigation={
	TopNames = RL["Ability Name"],
	TopCount = RL["Count"],
	TopAmount = RL["Damage"],
	BotNames = L["Protected"],
	BotMin = RL["Min"],
	BotAvg = RL["Avg"],
	BotMax = RL["Max"],
	BotAmount = RL["Count"]
}
DetailTitles.DamageReducedBy={
	TopNames = RL["Ability Name"],
	TopCount = RL["Count"],
	TopAmount = RL["Damage"],
	BotNames = RL["Player/Mob Name"],
	BotMin = RL["Min"],
	BotAvg = RL["Avg"],
	BotMax = RL["Max"],
	BotAmount = RL["Count"]
}

local mActive={}
local Epsilon=0.000000000000000001
local math_floor = math.floor
function RecountMitigation:Round100(num)
	return math_floor((num * 100) + 0.5) / 100
end
function RecountMitigation:OnInitialize()
end
function RecountMitigation:OnEnable()
	if not Recount then return end
	RecountMitigation:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEvent")
	RecountMitigation:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED", "mEventHTD")
end
function RecountMitigation:OnDisable()
	RecountMitigation:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end
------------------
-- MELEE DAMAGE	--
------------------
function RecountMitigation:MeleeDamage(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing)
	RecountMitigation:CalDM(srcName, dstName, RL["Melee"], SPELLSCHOOL_PHYSICAL, amount, 0, timestamp, absorbed, blocked, resisted)
end
------------------
-- MELEE MISS	--
------------------
function RecountMitigation:MeleeMiss(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, missType, missAmount, missAmountNew)
	RecountMitigation:CalDM(srcName, dstName, RL["Melee"], SPELLSCHOOL_PHYSICAL, 0, 0, timestamp, missAmountNew, nil, nil)
end
------------------
-- SPELL DAMAGE	--
------------------
function RecountMitigation:SpellDamage(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags,spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing)
	if eventtype == "RANGE_DAMAGE" then spellSchool = school end
	if eventtype == "SPELL_PERIODIC_DAMAGE" then
		spellName = spellName .." ("..RL["DoT"]..")"
	end
	RecountMitigation:CalDM(srcName, dstName, spellName, spellSchool, amount, spellId, timestamp, absorbed, blocked, resisted)
end
------------------
-- SPELL MISS	--
------------------
function RecountMitigation:SpellMiss(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, missType, missAmount, missAmountNew)
	if eventtype == "RANGE_MISSED" then spellSchool = school end
		if eventtype == "SPELL_PERIODIC_MISSED" then
			spellName = spellName .." ("..RL["DoT"]..")"
		end
	RecountMitigation:CalDM(srcName, dstName, spellName, spellSchool, 0, spellId, timestamp, missAmountNew, nil, nil)
end
------------------
-- ENVIROMENTAL	--
------------------
function RecountMitigation:EnvironmentalDamage(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, enviromentalType, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing)
	RecountMitigation:CalDM("Environment", dstName, Recount:FixCaps(enviromentalType), school, amount, spellId, timestamp, absorbed, blocked, resisted)
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : MITIGATION BUFF APPLIED								--
--																	--
----------------------------------------------------------------------
function RecountMitigation:mBuffApplied(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, auraType, amount)
	if not mBuffs[spellId] and not mBuffsHTD[spellId] and not mAbsorbs[spellId] then return end
	if UnitIsUnit(dstName, "player") then dstName = UnitName("player") end
	if UnitIsUnit(srcName, "player") then srcName = UnitName("player") end
	
	if mBuffsHTD[spellId] then
		mBuffRemoveHTD[spellId] = mBuffRemoveHTD[spellId] or {}
		mBuffRemoveHTD[spellId]["dstName"] = dstName
		mBuffRemoveHTD[spellId]["timer"] = RecountMitigation:ScheduleTimer("mBuffRemoved", ({mBuffsHTD[spellId]()}) [2], spellId)
	end
	
	mActive[dstName] = mActive[dstName] or {}
	if mActive[dstName][spellId] and mBuffsHTD[spellId] then
		RecountMitigation:CancelTimer(mBuffRemoveHTD[spellId]["timer"], false)
		mBuffRemoveHTD[spellId]["timer"] = RecountMitigation:ScheduleTimer("mBuffRemoved", ({mBuffsHTD[spellId]()}) [2], spellId)
	end
	--print("Mitigation Buff: ", spellName, "[", spellId, "] applied")
	mActive[dstName][spellId] = timestamp
	if mAbsorbs[spellId] then
		mLeft[spellId] = (mAbsorbs[spellId]())
		--print("Mitigation Buff: ", spellName, "[", spellId, "] applied for ", mLeft[spellId])
	end
	--print(UnitBuff("player", spellName))
		--local name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 = UnitBuff("player", spellName )
		--print("Name: ", name, " Value1: ", value1, " Value2: ", value2, " Value3: ", value3)
	--name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 
	
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : MITIGATION BUFF REMOVED								--
--																	--
----------------------------------------------------------------------
function RecountMitigation:mBuffRemoved(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, auraType, amount)
	if not mBuffs[spellId] and not mBuffsHTD[spellId] and not mBuffRemoveHTD[timestamp] and not mAbsorbs[spellId] then return end
	if mBuffRemoveHTD[timestamp] then
		dstName = mBuffRemoveHTD[timestamp]["dstName"]
		spellId = timestamp
		mBuffRemoveHTD[spellId] = nil
	end
	local dstDRBuffs = mActive[dstName]
	if not dstDRBuffs or not dstDRBuffs[spellId] then return end
	--print("Mitigation Buff: ", spellName, "[", spellId, "] removed")
	mActive[dstName][spellId] = nil
end

local mEvent =
{
	["SWING_DAMAGE"]			= RecountMitigation.MeleeDamage,
	["SWING_MISSED"]			= RecountMitigation.MeleeMiss,
	["RANGE_DAMAGE"]			= RecountMitigation.SpellDamage,
	["RANGE_MISSED"]			= RecountMitigation.SpellMiss,
	["SPELL_DAMAGE"]			= RecountMitigation.SpellDamage,
	["SPELL_MISSED"]			= RecountMitigation.SpellMiss,
	["SPELL_PERIODIC_DAMAGE"]	= RecountMitigation.SpellDamage,
	["SPELL_PERIODIC_MISSED"]	= RecountMitigation.SpellMiss,
	["DAMAGE_SHIELD"]			= RecountMitigation.SpellDamage,
	["DAMAGE_SPLIT"]			= RecountMitigation.SpellDamage,
	["ENVIRONMENTAL_DAMAGE"]	= RecountMitigation.EnvironmentalDamage,
	["SPELL_AURA_APPLIED"]		= RecountMitigation.mBuffApplied,
	["SPELL_AURA_REFRESH"]		= RecountMitigation.mBuffApplied,
	["SPELL_AURA_REMOVED"]		= RecountMitigation.mBuffRemoved,
}

local mEventList
----------------------------------------------------------------------
--																	--
--  FUNCTION : COMBAT LOG EVENT										--
--																	--
----------------------------------------------------------------------
function RecountMitigation:CombatLogEvent(_,timestamp, eventtype, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, dstRaidFlags, ...)
	if dstName and UnitIsUnit(dstName, "player") then dstName = UnitName("player") else return end
	if not Recount.db.profile.GlobalDataCollect or not Recount.CurrentDataCollect then return end
	if not Recount:CheckRetentionFromFlags(srcFlags) and not Recount:CheckRetentionFromFlags(dstFlags) then return end
	if srcName then	Recount:MatchGUID(srcName, srcGUID, srcFlags) else srcName = "No One" end

	mEventList = mEvent[eventtype]
	if mEventList then
		mEventList(self, timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
	end
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : UNIT SPELLCAST SUCCEEDED	EVENT FOR HTD BUFFS			--
--																	--
----------------------------------------------------------------------
function RecountMitigation:mEventHTD(eventtype, unitId, spellName, rank, lineId, spellId, timestamp)
	if unitId and UnitIsUnit(unitId, "player") then unitId = UnitName("player") else return end
	if not mBuffsHTD[spellId] then return end
	RecountMitigation:mBuffApplied(time(), eventtype, srcGUID, unitId, srcFlags, dstGUID, unitId, dstFlags, spellId, spellName, spellSchool, auraType, amount)
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : CALCULATE DAMAGE MITIGATION							--
--																	--
----------------------------------------------------------------------
function RecountMitigation:CalDM(source, victim, spellName, spellSchool, damage, spellId, timestamp, absorbed, blocked, resisted)
	if UnitIsUnit(victim, "player") then victim = UnitName("player") end
	if UnitIsUnit(source, "player") then source = UnitName("player") end
	if spellName == nil then
		--print("spellName Unknown - spellId: ", spellId)
		spellName = "Unknown"
	end
	--------------
	-- BLOCKED	--
	--------------
	if blocked ~= nil then
		RecountMitigation:AddDM("Blocked", blocked, "Blocked", victim)
	end
	--------------
	-- ABSORBED	--
	--------------
	if absorbed ~= nil then
		mAbsorbed = absorbed
		for mAbsorbId, mAbsorb in pairs(mAbsorbs) do
			--if physical absorb is true and attack was a spell then dont continue 
			if ({mAbsorbs[mAbsorbId]()}) [2] and spellSchool ~= SPELLSCHOOL_PHYSICAL then break end
			local mAbsorbName = GetSpellInfo(mAbsorbId)
			if mLeft[mAbsorbId] and mAbsorbed > 0 then	
				if mAbsorbed >= mLeft[mAbsorbId] then
					mAbsorbedAmount = mLeft[mAbsorbId]
					mLeft[mAbsorbId] = nil
					mAbsorbed = mAbsorbed - mAbsorbedAmount
				else
					mLeft[mAbsorbId] = mLeft[mAbsorbId] - mAbsorbed
					mAbsorbedAmount = mAbsorbed
					mAbsorbed = 0
				end
				RecountMitigation:AddDM(mAbsorbName, mAbsorbedAmount, mAbsorbName, victim)
			end
		end
		if mAbsorbed > 0 then
			RecountMitigation:AddDM("Absorbed", mAbsorbed, "Absorbed", victim)
			mAbsorbed = 0
		end
	end
	--------------
	-- RESISTED	--
	--------------
	if resisted ~= nil then
		RecountMitigation:AddDM("Resisted", resisted, "Resisted", victim)
	end	
	----------------------------
	-- DAMAGE MITIGATION BUFF --
	----------------------------
	local dstDRBuffs = mActive[victim]
	if not dstDRBuffs then return end
	if damage <= 0 and ((absorbed or 0) + (blocked or 0) + (resisted or 0)) <= 0 then return end
	
	local mPhysical = 0
	local mMagical = 0
	local mPhysicalTotal = 0
	local mMagicalTotal = 0
	for mSpellId, dmBuffed in pairs(dstDRBuffs) do
		if not dmBuffed then return end
		if mBuffAll[mSpellId] then
			mPhysical = 1 - ((1-mPhysical)*(1-(mBuffAll[mSpellId]())))
			mMagical  = 1 - ((1-mMagical)*(1-(mBuffAll[mSpellId]())))
			mPhysicalTotal = mPhysicalTotal + (mBuffAll[mSpellId]())
			mMagicalTotal = mMagicalTotal + (mBuffAll[mSpellId]())
		end
		if mBuffPhysical[mSpellId] then
			mPhysical = 1 - ((1-mPhysical)*(1-(mBuffPhysical[mSpellId]())))
			mPhysicalTotal = mPhysicalTotal + (mBuffPhysical[mSpellId]())
		end
		if mBuffMagical[mSpellId] then
			mMagical  = 1 - ((1-mMagical)*(1-(mBuffMagical[mSpellId]())))
			mMagicalTotal = mMagicalTotal + (mBuffMagical[mSpellId]())
		end
		if mBuffAllHTD[mSpellId] then
			mPhysical = 1 - ((1-mPhysical)*(1-(mBuffAllHTD[mSpellId]())))
			mMagical  = 1 - ((1-mMagical)*(1-(mBuffAllHTD[mSpellId]())))
			mPhysicalTotal = mPhysicalTotal + (mBuffAllHTD[mSpellId]())
			mMagicalTotal = mMagicalTotal + (mBuffAllHTD[mSpellId]())
		end
		if mBuffPhysicalHTD[mSpellId] then
			mPhysical = 1 - ((1-mPhysical)*(1-(mBuffPhysicalHTD[mSpellId]())))
			mPhysicalTotal = mPhysicalTotal + (mBuffPhysicalHTD[mSpellId]())
		end
		if mBuffMagicalHTD[mSpellId] then
			mMagical  = 1 - ((1-mMagical)*(1-(mBuffMagicalHTD[mSpellId]())))
			mMagicalTotal = mMagicalTotal + (mBuffMagicalHTD[mSpellId]())
		end
	end
	
	for mSpellId, dmBuffed in pairs(dstDRBuffs) do
		if not dmBuffed or mAbsorbs[mSpellId] then return end
		if spellSchool == SPELLSCHOOL_PHYSICAL then
			if damage <= 0 then
				damage = ((absorbed or 0) + (blocked or 0) + (resisted or 0))
			end
			if mBuffs[mSpellId] then
				mAmount = math_floor((((math.ceil(damage/(1-mPhysical))*mPhysical) / mPhysicalTotal)*((mBuffs[mSpellId]())))+0.5+Epsilon)
			end
			if mBuffsHTD[mSpellId] then
				mAmount = math_floor((((math.ceil(damage/(1-mPhysical))*mPhysical) / mPhysicalTotal)*((mBuffsHTD[mSpellId]())))+0.5+Epsilon)
			end
		else
			if damage <= 0 then
				damage = ((absorbed or 0) + (blocked or 0) + (resisted or 0))
			end
			if mBuffs[mSpellId] then
				mAmount = math_floor((((math.ceil(damage/(1-mPhysical))*mMagical) / mMagicalTotal)*((mBuffs[mSpellId]())))+0.5+Epsilon)
			end
			if mBuffsHTD[mSpellId] then
				mAmount = math_floor((((math.ceil(damage/(1-mPhysical))*mMagical) / mMagicalTotal)*((mBuffsHTD[mSpellId]())))+0.5+Epsilon)
			end
		end
		--if not mAmount and mAmount > 0 then
		if mAmount > 0 then
			local mSpellName = GetSpellInfo(mSpellId)
			--if mAmount > 200000 then
				--print("Error? mAmount: ", mAmount, " OrgHit: ")
			--end
			RecountMitigation:AddDM(spellName, mAmount, mSpellName, victim)
		end
	end
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : ADD DAMAGE MITIGATION								--
--																	--
----------------------------------------------------------------------
function RecountMitigation:AddDM(spellName, mAmount, mSpellName, victim)
	if Recount.db2.combatants[victim] then
		local sourceData = Recount.db2.combatants[victim]
		Recount:AddAmount(sourceData, "TotalDamageMitigation", mAmount)
		Recount:AddTableDataStats(sourceData, "DamageMitigation", spellName, victim, mAmount)
		Recount:AddTableDataStats(sourceData, "DamageReducedBy", mSpellName, victim, mAmount)
	end
end

function RecountMitigation:DataModesDamageMitigation(data, num)
	if not data then return 0, 0 end
	if num == 1 then
		return RecountMitigation:Round100((data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0), (data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0)/((data.Fights[Recount.db.profile.CurDataSet].ActiveTime or 0) + Epsilon))
	else
		return (data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0), {{data.Fights[Recount.db.profile.CurDataSet].DamageReducedBy, " "..L["'s Damage Mitigation Abilities"], DetailTitles.DamageReducedBy}, {data.Fights[Recount.db.profile.CurDataSet].DamageMitigation, L["'s Damage Mitigation"], DetailTitles.DamageMitigation}}
	end
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : DAMAGE MITIGATION TOOLTIP							--
--																	--
----------------------------------------------------------------------
function RecountMitigation:TooltipFuncsDamageMitigation(name, data)
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	tTotal = {}
	tTotal[L["Incoming Damage"]] = {}
	tTotal[L["Incoming Damage"]]["amount"] = (data.Fights[Recount.db.profile.CurDataSet].DamageTaken or 0) + (data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0)
	Recount:AddSortedTooltipData(L["Incoming Damage Before Mitigation"], tTotal,1)
	GameTooltip:AddLine("")
	tBreakdown = {}
	tBreakdown[L["Damage Taken"]] = {}
	tBreakdown[L["Damage Mitigated"]] = {}
	tBreakdown[L["Damage Taken"]]["amount"] = (data.Fights[Recount.db.profile.CurDataSet].DamageTaken or 0)
	tBreakdown[L["Damage Mitigated"]]["amount"] = (data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0)
	Recount:AddSortedTooltipData(L["of Incoming Damage"], tBreakdown,2)
	GameTooltip:AddLine("")
	tSelfHeals = {}
	tSelfHeals[L["Damage Self Healed"]] = {}
	tSelfHeals[L["Damage Not Actioned"]] = {}
	if data.Fights[Recount.db.profile.CurDataSet].HealedWho and data.Fights[Recount.db.profile.CurDataSet].HealedWho[UnitName("player")] and data.Fights[Recount.db.profile.CurDataSet].HealedWho[UnitName("player")]["amount"] then
		SelfHeals = data.Fights[Recount.db.profile.CurDataSet].HealedWho[UnitName("player")]["amount"]
	end
	tSelfHeals[L["Damage Self Healed"]]["amount"] = (SelfHeals or 0) - (data.Fights[Recount.db.profile.CurDataSet].Absorbs or 0)
	tSelfHeals[L["Damage Not Actioned"]]["amount"] = (data.Fights[Recount.db.profile.CurDataSet].DamageTaken or 0) - ((SelfHeals or 0) - (data.Fights[Recount.db.profile.CurDataSet].Absorbs or 0))
	Recount:AddSortedTooltipData(L["of Damage Taken"], tSelfHeals,2)
	GameTooltip:AddLine("")
	Recount:AddSortedTooltipData(L["of Damage Mitigated (Top 3)"], data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet].DamageReducedBy, 3)
	GameTooltip:AddLine("<"..RL["Click for more Details"]..">",0,0.9,0)
end

Recount:AddModeTooltip(L["Damage Mitigation"], RecountMitigation.DataModesDamageMitigation, RecountMitigation.TooltipFuncsDamageMitigation, nil,nil,nil,nil)